package strawberry.configure;

import com.sun.faces.renderkit.RenderKitFactoryImpl;
import com.sun.faces.util.Util;
import javax.faces.render.RenderKit;
import javax.faces.render.RenderKitFactory;
import javax.faces.render.Renderer;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import dwarf.Constants;
/**
 * Created on 2007/02/11
 * @author masa
 */
public class RenderKitFactoryInitializerEx {
  
  static final Log log = LogFactory.getLog(RenderKitFactoryInitializerEx.class);

  
  public RenderKitFactory configureRenderKits() {

    RenderKitFactory rkFactory = new RenderKitFactoryImpl();
    
    RenderKit rk = rkFactory.getRenderKit(null, RenderKitFactory.HTML_BASIC_RENDER_KIT);
    log.trace("rk = " + rk);
    configureRenderKits( rk);
    return rkFactory;
  }

  public void configureRenderKits(RenderKit rk) {
    addRenderKits(rk, standardRenders);
  }
  
  public void addRenderKits(RenderKit rk, String[] renders) {
    for (int i = 0; i < renders.length; i+= 3) {
      String componentFamily = renders[i + 0];
      String rendererType    = renders[i + 1];
      String rendererClass   = renders[i + 2];

      log.trace("addRenderer(" + componentFamily + ", " + rendererType + ", " + rendererClass);

      Renderer r = null;
      try {
        r = (Renderer)  Util.loadClass( rendererClass, this).newInstance();
      } catch (Exception ex) {
        log.error(ex.getMessage() + " --- "  + rendererClass);
      }
      if (r != null)
        rk.addRenderer(componentFamily,  rendererType,  r);
    }
  }
  
  String[] standardRenders = {
    "facelets",             "facelets.ui.Repeat",  "com.sun.facelets.component.RepeatRenderer",

    // ςƁACxg̃u[hLXgȂȂH
//    "javax.faces.Command",   "javax.faces.Button", "com.sun.faces.renderkit.html_basic.ButtonRenderer",
    "javax.faces.Command",   "javax.faces.Button", "com.sun.faces.modify.ButtonRenderer",


    "javax.faces.Command",   "javax.faces.Link",   "com.sun.faces.renderkit.html_basic.CommandLinkRenderer",
    "javax.faces.Data",      "javax.faces.Table",  "com.sun.faces.renderkit.html_basic.TableRenderer",

    "javax.faces.Form",     "javax.faces.Form",  "com.sun.faces.renderkit.html_basic.FormRenderer",
    "javax.faces.Graphic", "javax.faces.Image", "com.sun.faces.renderkit.html_basic.ImageRenderer",
    "javax.faces.Input",   "javax.faces.Hidden", "com.sun.faces.renderkit.html_basic.HiddenRenderer",
    "javax.faces.Input",   "javax.faces.Secret", "com.sun.faces.renderkit.html_basic.SecretRenderer",
    "javax.faces.Input",    "javax.faces.Text",  "com.sun.faces.renderkit.html_basic.TextRenderer",
    "javax.faces.Input",   "javax.faces.Textarea", "com.sun.faces.renderkit.html_basic.TextareaRenderer",



    "javax.faces.Messages", "javax.faces.Messages", "com.sun.faces.renderkit.html_basic.MessagesRenderer",
    "javax.faces.Message", "javax.faces.Message", "com.sun.faces.renderkit.html_basic.MessageRenderer",
    "javax.faces.Output", "javax.faces.Format", "com.sun.faces.renderkit.html_basic.OutputMessageRenderer",
    "javax.faces.Output", "javax.faces.Label",  "com.sun.faces.renderkit.html_basic.LabelRenderer",


    "javax.faces.Output", "javax.faces.Text", "com.sun.faces.renderkit.html_basic.TextRenderer",

    "javax.faces.Panel", "javax.faces.Grid", "com.sun.faces.renderkit.html_basic.GridRenderer",
    "javax.faces.Panel", "javax.faces.Group", "com.sun.faces.renderkit.html_basic.GroupRenderer",

    "javax.faces.SelectBoolean", "javax.faces.Checkbox", "com.sun.faces.renderkit.html_basic.CheckboxRenderer",

    "javax.faces.SelectMany", "javax.faces.Checkbox", "com.sun.faces.renderkit.html_basic.SelectManyCheckboxListRenderer",

    "javax.faces.SelectMany", "javax.faces.Listbox", "com.sun.faces.renderkit.html_basic.ListboxRenderer",
    "javax.faces.SelectMany", "javax.faces.Menu",  "com.sun.faces.renderkit.html_basic.MenuRenderer",
    "javax.faces.SelectOne", "javax.faces.Listbox", "com.sun.faces.renderkit.html_basic.ListboxRenderer",
    "javax.faces.SelectOne", "javax.faces.Menu", "com.sun.faces.renderkit.html_basic.MenuRenderer",
    "javax.faces.SelectOne", "javax.faces.Radio", "com.sun.faces.renderkit.html_basic.RadioRenderer",

  
    
  };
  
}
